diff -ur sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2019-06-22 07:43:44.237400000 +1000
+++ source/scripts/jmgBearHunter.cpp	2019-08-20 10:11:06.805000100 +1000
@@ -3251,6 +3677,7 @@
 	JMG_Bear_Hunter_Game_Control::spawnGroup = 4;
 	actionUpdate = 0;
 	attackingPlayer = false;
+	enemyId = 0;
 	Set_Skin(obj,"Blamo");
 	Commands->Set_Shield_Type(obj,"Blamo");
 	int finalMultiplier = JMG_Bear_Hunter_Game_Control::spawnKarma > 5 ? 2 : 1;
@@ -3287,7 +3714,10 @@
 	Commands->Set_Animation(jump,"rabbitJump.rabbitJump",false,0,0.0f,90.0f,false);
 	Commands->Attach_To_Object_Bone(obj,jump,"Bunny");
 	jumperId = Commands->Get_ID(jump);
-	obj->As_SoldierGameObj()->Set_Scale_Across_Network(1.5f);
+	SoldierGameObj *soldierGameObj = obj->As_SoldierGameObj();
+	soldierGameObj->Set_Scale_Across_Network(1.5f);
+	soldierGameObj->Set_Override_Muzzle_Direction(true);
+	soldierGameObj->Set_Can_Play_Damage_Animations(false);
 	Commands->Start_Timer(obj,this,3.0f,1);
 }
 void JMG_Bear_Hunt_Final_Boss::Enemy_Seen(GameObject *obj,GameObject *seen)	
@@ -3304,19 +3734,21 @@
 		return;
 	if (JMG_Bear_Hunter_Game_Control::aiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(seen)])
 		return;
-	 enemyId = Commands->Get_ID(seen);
-	 if (!JMG_Bear_Hunter_Game_Control::playersDead && enemyId == JMG_Bear_Hunter_Game_Control::mutantTargetId)
-		 return;
-	 if (Commands->Is_A_Star(seen))
-	 {
+	int seenId = Commands->Get_ID(seen);
+	if (seenId == JMG_Bear_Hunter_Game_Control::mutantTargetId)
+		return;
+	targetIsMine = false;
+	enemyId = seenId;
+	if (Commands->Is_A_Star(seen))
+	{
 		attackingPlayer = true;;
 		targetUpdate = 40;
-	 }
-	 else
-	 {
+	}
+	else
+	{
 		attackingPlayer = false;
 		targetUpdate = 0;
-	 }
+	}
 }
 void JMG_Bear_Hunt_Final_Boss::Timer_Expired(GameObject *obj,int number)
 {
@@ -3365,6 +3797,12 @@
 			return;
 		Vector3 pos = Commands->Get_Position(obj);
 		GameObject *target = enemyId ? Commands->Find_Object(enemyId) : NULL;
+		if (Get_C4_Attached(target) == obj)
+		{
+			enemyId = 0;
+			target = NULL;
+		}
+		MineHunt(obj,pos,target);
 		ChooseTarget(obj,pos,target);
 		if (targetUpdate)
 			targetUpdate--;
@@ -3398,7 +3836,7 @@
 			if (JmgUtility::SimpleDistance(Commands->Get_Position(o),bossPos) <= 4.0f)
 				SnackTime(obj,o);
 		}
-		Commands->Start_Timer(obj,this,0.25f,2);
+		Commands->Start_Timer(obj,this,0.1f,2);
 	}
 }
 void JMG_Bear_Hunt_Final_Boss::Damaged(GameObject *obj,GameObject *damager,float damage)
@@ -3432,23 +3870,25 @@
 	}
 	lastHealth = Commands->Get_Health(obj);
 	lastArmor = Commands->Get_Shield_Strength(obj);
-	if (damage <= 0 || !damager || obj == damager || (enemyId && targetUpdate) || enemyId == Commands->Get_ID(damager) || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
+	int damagerId = Commands->Get_ID(damager);
+	if (damage <= 0 || !damager || obj == damager || (enemyId && targetUpdate) || enemyId == damagerId || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
 		return;
 	if (JMG_Bear_Hunter_Game_Control::aiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(damager)])
 		return;
 	if (enemyId && JmgUtility::SimpleDistance(Commands->Get_Position(damager),Commands->Get_Position(obj)) > targetDistance)
 		return;
-	 enemyId = Commands->Get_ID(damager);
-	 if (Commands->Is_A_Star(damager))
-	 {
+	targetIsMine = false;
+	enemyId = damagerId;
+	if (Commands->Is_A_Star(damager))
+	{
 		attackingPlayer = true;
 		targetUpdate = 40;
-	 }
-	 else
-	 {
+	}
+	else
+	{
 		attackingPlayer = false;
 		targetUpdate = 0;
-	 }
+	}
 }
 void JMG_Bear_Hunt_Final_Boss::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason reason)
 {
@@ -3482,6 +3922,7 @@
 		sprintf(deathMsg,"A %s killed the giant Mutant Rabbit!",Get_Translated_Preset_Name(killer));
 	JmgUtility::MessageAllPlayers(255,255,0,deathMsg);
 	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We did it, the President of Corporate America has been saved!");
+	JmgUtility::Create_2D_Wave_Sound_Dialog("BH73.mp3");
 	NewObjectiveSystemControl.Set_Objective_Status(8,NewObjectiveSystem::Accomplished);
 }
 void JMG_Bear_Hunt_Final_Boss::AttackTarget(GameObject *obj,GameObject *target,float distance)
@@ -3489,11 +3930,11 @@
 	int tempId = Commands->Get_ID(target);
 	if (targetedId == tempId && actionUpdate)
 		return;
-	actionUpdate = 10;
+	actionUpdate = 40;
 	Commands->Action_Reset(obj,10);
 	targetedId = tempId;
 	ActionParamsStruct params;
-	params.Set_Movement(target,moveSpeed,target->As_SoldierGameObj() ? 0.0f : 5.0f,false);
+	params.Set_Movement(target,moveSpeed,targetIsMine ? 5.0f : (target->As_SoldierGameObj() ? 0.0f : 5.0f),false);
 	params.MovePathfind = true;
 	Commands->Action_Goto(obj,params);
 	if ((distance < 40000.0f && JMG_Bear_Hunter_Game_Control::mutantTargetId != targetedId) || distance < 625)
@@ -3501,7 +3942,10 @@
 	else
 		params.AttackForceFire = false;
 	params.Set_Basic(this,100,10,AI_STATE_COMBAT);
-	params.Set_Attack(target,200.0f,0.0f,Get_Player_Count() <= 10 ? true : false);
+	if (JMG_Bear_Hunter_Game_Control::mutantTargetId == targetedId)
+		params.Set_Attack(Commands->Get_Bone_Position(target,"c pelvis"),200.0f,0.0f,Get_Player_Count() <= 10 ? true : false);
+	else
+		params.Set_Attack(target,200.0f,0.0f,Get_Player_Count() <= 10 ? true : false);
 	Commands->Action_Attack(obj,params);
 }
 void JMG_Bear_Hunt_Final_Boss::Respawn(GameObject *obj)
@@ -3534,6 +3978,7 @@
 				closestDist = tempDist;
 				target = aiPlayer;
 				enemyId = Commands->Get_ID(aiPlayer);
+				targetIsMine = false;
 				attackingPlayer = true;
 			}
 		}
@@ -3554,6 +3999,7 @@
 				closestDist = tempDist;
 				target = player;
 				enemyId = Commands->Get_ID(player);
+				targetIsMine = false;
 				attackingPlayer = true;
 			}
 		}
@@ -3611,6 +4057,35 @@
 			node->EatenByRabbit++;
 	}
 }
+void JMG_Bear_Hunt_Final_Boss::MineHunt(GameObject *obj,Vector3 myPos,GameObject *enemy)
+{
+	float nearest = 0.0f;
+	GameObject *c4 = NULL;
+	Vector3 headPos = Commands->Get_Bone_Position(obj,"c headt");
+	for (SLNode<C4GameObj> *current = GameObjManager::C4GameObjList.Head();current;current = current->Next())
+	{
+		GameObject *object = (SmartGameObj *)current->Data();
+		if (Get_C4_Attached(object) == obj)
+			continue;
+		Vector3 targetPos = Commands->Get_Position(object);
+		float dist = JmgUtility::SimpleDistance(targetPos,myPos);
+		targetPos.Z += 0.1f;
+		CastResultStruct res;
+		LineSegClass ray(headPos,targetPos);
+		PhysRayCollisionTestClass coltest(ray,&res,SOLDIER_GHOST_COLLISION_GROUP);
+		PhysicsSceneClass::Get_Instance()->Cast_Ray(coltest,false);
+		if ((!c4 || dist < nearest) && coltest.CollidedRenderObj)
+		{
+			c4 = object;
+			nearest = dist;
+		}
+	}
+	if ((c4 && Commands->Get_ID(c4) != enemyId && nearest < JmgUtility::SimpleDistance(myPos,Commands->Get_Position(enemy))) || (!enemy && c4))
+	{
+		targetIsMine = true;
+		enemyId = Commands->Get_ID(c4);
+	}
+}
 void JMG_Bear_Hunter_Spectator::Created(GameObject *obj)
 {
 	Commands->Set_Player_Type(obj,-4);
@@ -3633,6 +4108,9 @@
 	if (mphys)
 		mphys->Find_Teleport_Location(pos,1.0f,&pos);
 	Commands->Set_Position(obj,pos);
+	char params[220];
+	sprintf(params,"0.1,%.2f",posNode->facing);
+	Commands->Attach_Script(obj,"JMG_Utility_Delay_Then_Rotate_Camera",params);
 }
 void JMG_Bear_Hunter_Spectator::Destroyed(GameObject *obj)
 {
@@ -3715,7 +4193,7 @@
 			SetAIState(obj,MoveToCabin,Vector3(),5.0f,0.85f,aiDefensePoints[1].GetRandom(0));
 		if (aiState == NoAction && !enemyId)
 			ChooseAction(obj);
-		if ((aiState == AccessPT || aiState == PTReload) && JmgUtility::SimpleDistance(Commands->Get_Position(obj),targetDestination) <= requiredDestinationRange)
+		if ((aiState == AccessPT || aiState == PTReload) && JmgUtility::SimpleFlatDistance(Commands->Get_Position(obj),targetDestination) <= requiredDestinationRange)
 		{
 			if (aiState == PTReload)
 			{
@@ -4110,6 +4588,10 @@
 	Commands->Attach_Script(obj,"JMG_RP2_Set_Object_Team_On_Timer","14.3,68541,-3");
 	Commands->Attach_Script(obj,"JMG_RP2_Set_Physical_Collisions_On_Timer","17.5,68541,1 1 1");
 	CreateAObject(obj,NULL,"Daves Arrow","XG_HD_Harness","XG_HD_Harness.XG_HD_Harness",createLocation,origFacing,0,"none",437,1000);
+	createLocation.Z -= 1.25f;
+	GameObject *flare = Commands->Create_Object("Vehicle_Signal_Flare",createLocation);
+	flare->As_PhysicalGameObj()->Peek_Physical_Object()->Set_Collision_Group(Collision_Group_Type::TERRAIN_AND_BULLET_COLLISION_GROUP);
+	flareId = Commands->Get_ID(flare);
 	Commands->Send_Custom_Event(obj,obj,92562142,0,15.0f);
 	Commands->Send_Custom_Event(obj,obj,92562143,0,25.0f);
 }
@@ -4148,6 +4630,9 @@
 	}
 	if (message == 92562142)
 	{
+		GameObject *flare = Commands->Find_Object(flareId);
+		if (flare)
+			Commands->Destroy_Object(flare);
 		Commands->Enable_Collisions(obj);
 		Commands->Set_Position(obj,origPos);
 		GameObject *Zone = Commands->Find_Object(Get_Int_Parameter("DeathZoneID"));
@@ -4763,7 +5248,10 @@
 		return;
 	if (JMG_Bear_Hunter_Game_Control::aiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(seen)])
 		return;
-	targetId = Commands->Get_ID(seen);
+	int seenId = Commands->Get_ID(seen);
+	if (seenId == JMG_Bear_Hunter_Game_Control::mutantTargetId)
+		return;
+	targetId = seenId;
 	targetUpdate = 20;
 }
 void JMG_Bear_Hunter_Engineer_AI::Timer_Expired(GameObject *obj,int number)
@@ -4952,6 +5440,8 @@
 		return false;
 	if (target->As_SoldierGameObj() && Get_Hitpoints(target) > Get_Max_Hitpoints(target)*repairSoldierVehicleTurret.X)
 		return false;
+	if (target->As_VehicleGameObj() && Get_Vehicle_Mode(target) != VEHICLE_TYPE_TURRET && !Get_Vehicle_Occupant_Count(target))
+		return false;
 	if (target->As_VehicleGameObj() && Get_Vehicle_Mode(target) != VEHICLE_TYPE_TURRET && Get_Hitpoints(target) > Get_Max_Hitpoints(target)*repairSoldierVehicleTurret.Y)
 		return false;
 	if (target->As_VehicleGameObj() && Get_Vehicle_Mode(target) == VEHICLE_TYPE_TURRET && (Get_Hitpoints(target) > Get_Max_Hitpoints(target)*repairSoldierVehicleTurret.Z || !JMG_Bear_Hunter_Power_Transformer::online))
@@ -5022,13 +5512,15 @@
 			oilRigCount++;
 			if (oilRigCount == 7)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Thats all of them, great work guys!");
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: That's all of the pump jacks in the North East, great work guys!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH74.mp3");
 				NewObjectiveSystemControl.Set_Objective_Status(16,NewObjectiveSystem::Accomplished);
 			}
 			else
 			{
 				char successMsg[220];
 				sprintf(successMsg,"Bear Rug Co: Oil rig on-line, %d more to go.",7-oilRigCount);
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH75.mp3");
 				JmgUtility::MessageAllPlayers(127,127,255,successMsg);
 				unsigned int textId = (oilRigCount == 1) ? 12752 : (oilRigCount == 2) ? 12753 : (oilRigCount == 3) ? 12754 : (oilRigCount == 4) ? 12755 : 12756;
 				NewObjectiveSystemControl.Set_Objective_Mission(16,textId,textId);
@@ -5067,10 +5559,10 @@
 		char params[256];
 		sprintf(params,"%s,%.2f,%.2f,1",Get_Parameter("RepairAnimation"),Get_Float_Parameter("StartFrame"),Get_Float_Parameter("EndFrame"));
 		Commands->Attach_Script(rig,"JMG_Bear_Hunter_Oil_Rig",params);
+		BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(obj));
 		if (NewObjectiveSystemControl.Set_Objective_Status(17,NewObjectiveSystem::Accomplished))
 		{
 			Commands->Give_Points(damager,250.0f,false);
-			BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(obj));
 			node->BonusObjectivesCompleted++;
 			node->totalObjectivesCompleted++;
 			node->ObjectiveOilRigsRepaired++;
@@ -5136,7 +5628,10 @@
 				if (JMG_Bear_Hunter_Game_Control::weaponsReturned[x])
 					count++;
 			if (count == 1)
-				NewObjectiveSystemControl.Add_Objective(19,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12784,"",12784,2);
+			{
+				JMG_Bear_Hunter_Game_Control::IncreaseBonusObjectiveCount(19);
+				NewObjectiveSystemControl.Add_Objective(19,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12784,"",12784,JMG_Bear_Hunter_Game_Control::bonusObjectiveCount);
+			}
 			else
 				NewObjectiveSystemControl.Set_Objective_Mission(19,12785-count,12785-count);
 		}
@@ -5165,13 +5660,27 @@
 			JMG_Bear_Hunter_Game_Control::weaponsUnlocked[Get_Int_Parameter("WeaponType")] = true;
 			switch (Get_Int_Parameter("WeaponType"))
 			{
-			case 0:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Good work, all infantry classes now have a Twin Bow.");break;
-			case 1:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Great work, basic infantry now have a 10 gauge shotgun.");break;
-			case 2:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Due to your hard work, tier 1 infantry now have a FAMAS F1.");break;
-			case 3:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Excellent work, tier 2 infantry now have the PPSh-41!");break;
-			case 4:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Enjoy the AA12 with your tier 3 infantry!");break;
-			case 5:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Engineers can now use the Beretta 93R.");break;
-			case 6:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Wow, looks like that bear had blueprints for a plasma rifle, all classes now have a plasma rifle!");break;
+			case 0:
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Good work, all infantry classes now have a Twin Bow.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH76.mp3");break;
+			case 1:
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Great work, basic infantry now have a 10 gauge shotgun.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH77.mp3");break;
+			case 2:
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Due to your hard work, tier 1 infantry now have a FAMAS F1.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH78.mp3");break;
+			case 3:
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Excellent work, tier 2 infantry now have the PPSh-41!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH79.mp3");break;
+			case 4:
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Enjoy the AA12 with your tier 3 infantry!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH80.mp3");break;
+			case 5:
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Engineers can now use the Beretta 93R.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH81.mp3");break;
+			case 6:
+				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Wow, looks like that deer had blueprints for a plasma rifle, all classes now have a plasma rifle!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH82.mp3");break;
 			}
 			if (Get_Int_Parameter("WeaponType") < 6)
 			{
@@ -5277,8 +5786,10 @@
 	}
 	if (NewObjectiveSystemControl.Get_Objective_Status(20) == NewObjectiveSystem::NotDefined)
 	{
-		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: That deer looks real exotic, kill it so we can stuff it and sell it for big bucks!!");
-		NewObjectiveSystemControl.Add_Objective(20,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12786,"",12786,6);
+		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: That deer looks real exotic, kill it so we can stuff it and sell it for big bucks!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH83.mp3");
+		JMG_Bear_Hunter_Game_Control::IncreaseBonusObjectiveCount(20);
+		NewObjectiveSystemControl.Add_Objective(20,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12786,"",12786,JMG_Bear_Hunter_Game_Control::bonusObjectiveCount);
 	}
 }
 void JMG_Bear_Hunter_Giant_Deer_Boss::Custom(GameObject *obj,int message,int param,GameObject *sender)
@@ -5401,12 +5912,15 @@
 	if (NewObjectiveSystemControl.Get_Objective_Status(20) == NewObjectiveSystem::NotDefined)
 	{
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: That deer looks real exotic, kill it so we can stuff it and sell it for big bucks!");
-		NewObjectiveSystemControl.Add_Objective(20,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12786,"",12786,6);
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH83.mp3");
+		JMG_Bear_Hunter_Game_Control::IncreaseBonusObjectiveCount(20);
+		NewObjectiveSystemControl.Add_Objective(20,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12786,"",12786,JMG_Bear_Hunter_Game_Control::bonusObjectiveCount);
 	}
 }
 void JMG_Bear_Hunter_Giant_Deer_Boss::Killed(GameObject *obj,GameObject *killer)
 {
-	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Good work killing that exotic deer, grab its carcass and return it to base and we’ll swap it out for a new weapon prototype we’re working on.");
+	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Good work killing that exotic deer, grab its carcass and return it to base and we'll swap it out for a new weapon prototype we're working on.");
+	JmgUtility::Create_2D_Wave_Sound_Dialog("BH84.mp3");
 	NewObjectiveSystemControl.Set_Objective_Mission(20,12787,12787);
 	Commands->Give_Points(killer,250.0f,false);
 	Vector3 pos = Commands->Get_Position(obj);
@@ -5478,6 +5992,8 @@
 		case 1000003566:case 1000003569:case 1000003571:node->WildDeerKilled++;break;
 		case 1000003573:case 1000003575:case 1000003577:node->WildSquirrelsKilled++;break;
 		case 1000003643:case 1000003647:case 1000003649:node->FriendlyTinyDeerKilled++;break;
+		case 1000000024:case 1000000026:case 1000000028:Commands->Get_Player_Type(obj) == 1 ? node->KilledFriendlyCougars++ : node->KilledCougars++;break;
+		case 1000000036:case 1000000038:case 1000000040:node->KilledMutantCougars++;break;
 		default:node->KilledHumanAi++;break;
 		}
 }
@@ -5593,17 +6109,20 @@
 	if (NewObjectiveSystemControl.Get_Objective_Status(21) == NewObjectiveSystem::NotDefined)
 	{
 		JmgUtility::DisplayChatMessage(poker,127,127,255,"Bear Rug Co: We have the Communications Tower turned off right now because it was scaring off the wild life, leave it off!");
+		Create_2D_Wave_Sound_Dialog_Player(poker,"BH85.mp3");
 		return;
 	}
 	if (NewObjectiveSystemControl.Get_Objective_Status(21) == NewObjectiveSystem::Removed)
 	{
 		JmgUtility::DisplayChatMessage(poker,127,127,255,"Bear Rug Co: Sorry, its too late to activate the tower now.");
+		Create_2D_Wave_Sound_Dialog_Player(poker,"BH86.mp3");
 		return;
 	}
 	Commands->Enable_HUD_Pokable_Indicator(obj,false);
 	Commands->Give_Points(obj,250.0f,false);
 	activated = true;
 	JmgUtility::MessageAllPlayers(127,127,255,"Distress Signal Transmission In Progress: We are under attack by mutants on Bear Island and we need help!");
+	JmgUtility::Create_2D_Wave_Sound_Dialog("BH87.mp3");
 	NewObjectiveSystemControl.Set_Objective_Mission(21,12790,12790);
 	Commands->Set_Animation(obj,"RdoTwrSwtch.RdoTwrSwtch",false,0,2.0f,2.0f,false);
 	GameObject *radioTower = Commands->Find_Object(JMG_Bear_Hunter_Radio_Tower_Control::radioTowerId);
@@ -5627,6 +6146,7 @@
 	if (NewObjectiveSystemControl.Get_Objective_Status(21) != NewObjectiveSystem::Accomplished)
 	{
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The communications tower was destroyed before anyone could answer our distress call!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH88.mp3");
 		NewObjectiveSystemControl.Set_Objective_Status(21,NewObjectiveSystem::Failed);
 	}
 	JMG_Bear_Hunter_Radio_Tower_Control::destroyed = true;
@@ -5668,6 +6188,7 @@
 		Set_Screen_Fade_Color_Player(enterer,0.102f,0.086f,0.098f,0.0f);
 		Set_Screen_Fade_Opacity_Player(enterer,0.9f,0.0f);
 		JMG_Bear_Hunter_Game_Control::diedInWater[JmgUtility::JMG_Get_Player_ID(enterer)] = true;
+		Commands->Attach_Script(enterer,"JMG_Utility_Apply_Damage_While_In_Zone_Attached","0.1f,99999.0f,None,0");
 	}
 	VehicleGameObj *vehicle = enterer->As_VehicleGameObj();
 	if (vehicle)
@@ -6231,7 +6752,8 @@
 {
 	if (NewObjectiveSystemControl.Get_Objective_Status(22) == NewObjectiveSystem::NotDefined)
 	{
-		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: President of Corporate America had some painkillers called in, they airdropped them outside of DERP, we'll pay everyone $1,000.00 if you can return it to the him.");
+		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The President of Corporate America had some painkillers called in, they airdropped them outside of DERP, we'll pay everyone $100.00 if you can return it to him.");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH89.mp3");
 		NewObjectiveSystemControl.Add_Objective(22,NewObjectiveSystem::Tertiary,NewObjectiveSystem::Pending,12795,"",12795,obj);
 	}
 	else
@@ -6299,6 +6821,7 @@
 			if (Commands->Get_Shield_Strength(obj) < 490.0f)
 			{
 				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The power substation is under attack, defend it or else we'll lose power to the turrets!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH90.mp3");
 				NewObjectiveSystemControl.Add_Objective(23,NewObjectiveSystem::Secondary,NewObjectiveSystem::Pending,12798,"",12798,obj);
 				objectiveActive = true;
 			}
@@ -6307,6 +6830,7 @@
 		else if (difftime(clock(),announceTime) > 10000.0f)
 		{
 			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The power substation is still under attack!");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH91.mp3");
 			announceTime = clock();
 		}
 	if (JMG_Bear_Hunter_Power_Transformer::online && !Commands->Get_Shield_Strength(obj))
@@ -6318,6 +6842,7 @@
 			playerScoreNode->RepairedSubstation--;
 		Commands->Set_Player_Type(obj,-2);
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The power substation has been critically damaged, all turrets are down, get out there and repair it!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH92.mp3");
 		Commands->Create_Explosion("Explosion_IonCannonBeacon",Vector3(187.902f,-721.522f,1.852f),0);
 		NewObjectiveSystemControl.Set_Objective_Mission(23,12799,12799);
 		Commands->Set_Animation(obj,"transformer.transformer",false,0,1.0,1.0,true);
@@ -6333,6 +6858,7 @@
 			playerScoreNode->RepairedSubstation++;
 		Commands->Set_Player_Type(obj,1);
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The power substation has been repaired, turrets back on-line, try to defend it this time!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH93.mp3");
 		NewObjectiveSystemControl.Set_Objective_Mission(23,12798,12798);
 		Commands->Set_Animation(obj,"transformer.transformer",false,0,0,0,true);
 		ToggleTurrets(true);
@@ -6449,7 +6975,7 @@
 		return;
 	if (Is_Script_Attached(seen,"JMG_AI_Ignore_Object"))
 		return;
-	if (Commands->Is_A_Star(seen) && JMG_Wandering_AI_Controller::aiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(seen)])
+	if (Commands->Is_A_Star(seen) && JMG_Bear_Hunter_Game_Control::wanderingAiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(seen)])
 		return;
 	if (vehicleChaseTimeReset && (seen->As_VehicleGameObj() || Get_Vehicle(seen)) && JmgUtility::SimpleDistance(Commands->Get_Position(obj),Commands->Get_Position(seen)) > 225)
 		return;
@@ -6648,7 +7174,7 @@
 		return;
 	if (!damaged && damage > 0)
 		damaged = true;
-	if (Commands->Is_A_Star(damager) && JMG_Wandering_AI_Controller::aiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(damager)])
+	if (Commands->Is_A_Star(damager) && JMG_Bear_Hunter_Game_Control::wanderingAiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(damager)])
 		return;
 	if (Is_Script_Attached(damager,"JMG_AI_Ignore_Object"))
 		return;
@@ -6677,7 +7203,7 @@
 		GameObject *target = Commands->Find_Object(currentTargetID);
 		int playerId = JmgUtility::JMG_Get_Player_ID(target);
 		if (playerId && Commands->Get_Health(target))
-			JMG_Wandering_AI_Controller::aiIgnorePlayers[playerId] = 30;
+			JMG_Bear_Hunter_Game_Control::wanderingAiIgnorePlayers[playerId] = 30;
 	}
 }
 void JMG_Wandering_AI::SoundDHeard(GameObject *obj,const CombatSound &sound)
@@ -6692,7 +7218,7 @@
 	bool Success = false;//(dist > 225 && Commands->Get_Random(0.00f,1.00f) > 0.015)fail
 	if (dist < 144)// Sound is near, must investigate
 		Success = true;
-	else if (sound.sound == 6 && dist < 250000 && Commands->Get_Random(0.00f,1.00f) < JMG_Wandering_AI_Controller::soundAttentionWhoreNotify)//player just wants to be noticed
+	else if (sound.sound == 6 && dist < 250000 && Commands->Get_Random(0.00f,1.00f) < JMG_Bear_Hunter_Game_Control::soundAttentionWhoreNotify)//player just wants to be noticed
 		Success = true;
 	else if (Commands->Get_Random(0.00f,1.00f) < 0.00025 && sound.sound != 5)// Bad Luck
 		Success = true;
@@ -6732,27 +7258,6 @@
 	}
 	return node->position;
 }
-void JMG_Wandering_AI_Controller::Created(GameObject *obj)
-{
-	for (int x = 0;x < 128;x++)
-		aiIgnorePlayers[x] = 0;
-	Commands->Start_Timer(obj,this,1.0f,1);
-}
-void JMG_Wandering_AI_Controller::Timer_Expired(GameObject *obj,int number)
-{
-	if (number == 1)
-	{
-		for (int x = 0;x < 128;x++)
-		{
-			if (aiIgnorePlayers[x] > 0)
-				aiIgnorePlayers[x]--;
-			GameObject *player = Get_GameObj(x);
-			if (player && !Is_Script_Attached(player,"JMG_Rp2_Dedicated_Server_Sound_Emulator"))
-			Commands->Attach_Script(player,"JMG_Rp2_Dedicated_Server_Sound_Emulator","");
-		}
-		Commands->Start_Timer(obj,this,1.0f,1);
-	}
-}
 void JMG_Wandering_AI_Controller::Destroyed(GameObject *obj)
 {
 	JMG_Wandering_AI_Controller::setup = false;
@@ -7412,9 +7917,14 @@
 }
 void JMG_Bear_Hunter_Armored_Car::Created(GameObject *obj)
 {
+	GameObject *effect = Commands->Create_Object("Armored_Car_Effect",Commands->Get_Position(obj));
+	Commands->Attach_To_Object_Bone(effect,obj,"origin");
+	effectRangeId = Commands->Get_ID(effect);
 	lightsOn = false;
 	Commands->Set_Animation(obj,"ArmoredCar.ArmoredCar",false,0,0,0,true);
 	Commands->Start_Timer(obj,this,0.1f,1);
+	Commands->Start_Timer(obj,this,1.0f,2);
+	Commands->Start_Timer(obj,this,0.1f,3);
 }
 void JMG_Bear_Hunter_Armored_Car::Timer_Expired(GameObject *obj,int number)
 {
